
import UIKit
import CloudKit

@main
class AppDelegate: UIResponder, UIApplicationDelegate {
   func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
      let userSettings = UserDefaults.standard
      let values = ["subscriptionSaved": false, "zoneCreated": false]
      userSettings.register(defaults: values)

      application.registerForRemoteNotifications()
      Task(priority: .background) {
         await AppData.configureDatabase()
      }
      return true
   }
   func application(_ application: UIApplication, didReceiveRemoteNotification userInfo: [AnyHashable : Any], fetchCompletionHandler completionHandler: @escaping (UIBackgroundFetchResult) -> Void) {
      let notification = CKNotification(fromRemoteNotificationDictionary: userInfo) as? CKDatabaseNotification
      guard notification != nil else {
         completionHandler(.failed)
         return
      }
      AppData.checkUpdates(finishClosure: { (result) in
         completionHandler(result)
      })
   }
   func application(_ application: UIApplication, configurationForConnecting connectingSceneSession: UISceneSession, options: UIScene.ConnectionOptions) -> UISceneConfiguration {
      return UISceneConfiguration(name: "Default Configuration", sessionRole: connectingSceneSession.role)
   }
}

